--- diehardc.c.orig	Wed Sep  9 08:59:04 1998
+++ diehardc.c	Fri Dec  6 16:42:28 2002
@@ -47,7 +47,6 @@
 #include <stdlib.h>
 #include <string.h>
 #include <math.h>
-#include <malloc.h>
 
 #define integer long
 #define real double
@@ -2304,7 +2303,7 @@ void cdbitst(char *filename)
             w[ui] = 0;
         }
 /* **** GENERATE 2**kpow OVERLAPPING WORDS********** */
-        for (ic = ((long)1<<kpow-5); ic >= 1; --ic) {
+        for (ic = ((long)1<<(kpow-5)); ic >= 1; --ic) {
             num = get_integer();
             for (ib = 1; ib <= 32; ++ib) {
 /*     *** GET NEW J ***** */
@@ -2391,7 +2390,7 @@ void sparse_occ(char *filename)
 
     /* Local variables */
     ulong mbit[32];
-    real true;
+    real istrue;
     real x, px;
     integer mkk;
     integer kount, ic;
@@ -2434,7 +2433,7 @@ void sparse_occ(char *filename)
 /* *********** INITIALIZE***************** */
         ntries = 1;
         kpow = 21;
-        true = exp(-pow(2.0, kpow-20.0)) * 1048576;
+        istrue = exp(-pow(2.0, kpow-20.0)) * 1048576;
 
         for (krk = 33 - word_size; krk >= 1; --krk) {
             rewind_input_file();
@@ -2477,7 +2476,7 @@ void sparse_occ(char *filename)
                     }
                 }
 /* ****END OF MAIN LOOP**** */
-                x = (kount - true) / sigs[testn];
+                x = (kount - istrue) / sigs[testn];
                 px = phi(x);
                 dprintf("%8s for %-15s using bits %2d to %2d %13ld %8.3f %6.4f\n",
                         ctest[testn], filename, 33-kr-word_size, 32-kr, kount, x, px);
@@ -3189,7 +3188,7 @@ void squeeze_test(char *filename)
 
         do {
             ++j;
-            k = k * get_double() + 1;
+            k = (integer)(k * get_double() + 1);
             icount++;
         } while (k > 1);
 
@@ -3649,6 +3648,21 @@ struct rngtest {
     char *name;
 };
 
+static void diegets(char* buf, size_t len)
+{
+    char *p;
+    if (fgets(buf, len, stdin) == NULL) {
+        perror("invalid input");
+        exit(1);
+    }
+    p = strchr(buf, '\n');
+    if (p == NULL) {
+        fprintf(stderr, "input line too long\n");
+        exit(1);
+    }
+    *p = '\0';
+}
+
 int main(int argc, char *argv[])
 {
     char filename[80];
@@ -3685,14 +3699,14 @@ int main(int argc, char *argv[])
     } else {
         print_text(intro_text);
         printf( " Enter binary filename to test:\n");
-        gets(filename);
+        diegets(filename, sizeof filename);
     }
 
     if (argc > 2) {
         strcpy(fileout, argv[2]);
     } else {
         printf( " Enter name of output file:\n");
-        gets(fileout);
+        diegets(fileout, sizeof fileout);
     }
 
     ofile = fopen(fileout, "w");
@@ -3716,7 +3730,7 @@ int main(int argc, char *argv[])
         }
         printf( " Enter your choices using 16 columns, '1'=yes, 's'=silent '0'=no.\n");
         printf("123456789012345S\n");
-        gets(which);
+        diegets(which, sizeof which);
     }
 
     for(i=0; i<16; i++) {
